.SUFFIXES: .cpp .c .obj .dll .exe .rc .res


CXX=dmc
CC=dmc -cpp
LIB=lib
LINK=dmc
RC=rc

LIB_BASENAME=stlport_dm

OBJS = build\c_locale.obj build\c_locale_stub.obj build\codecvt.obj \
	build\collate.obj build\complex.obj build\complex_exp.obj \
	build\complex_io.obj build\complex_io_w.obj build\complex_trig.obj \
	build\ctype.obj build\dll_main.obj \
	build\facets_byname.obj build\fstream.obj build\ios.obj \
	build\iostream.obj build\istream.obj build\locale.obj \
	build\locale_catalog.obj build\locale_impl.obj \
	build\messages.obj build\monetary.obj build\num_get.obj \
	build\num_get_float.obj build\num_put.obj \
	build\num_put_float.obj build\numpunct.obj build\ostream.obj \
	build\sstream.obj build\stdio_streambuf.obj \
	build\streambuf.obj build\string_w.obj build\strstream.obj \
	build\time_facets.obj


CXXFLAGS_COMMON = -Ae -Ar -D_STLP_NO_FORCE_INSTANTIATE -DSTRICT -I../stlport

CXXFLAGS_RELEASE_static = $(CXXFLAGS_COMMON) -o+all
CXXFLAGS_RELEASE_dynamic = $(CXXFLAGS_COMMON) -D_STLP_DESIGNATED_DLL -o+all -ND -WD

CXXFLAGS_DEBUG_static = $(CXXFLAGS_COMMON) -g
CXXFLAGS_DEBUG_dynamic = $(CXXFLAGS_COMMON) -D_STLP_DESIGNATED_DLL -g -ND -WD

CXXFLAGS_STLDEBUG_static = $(CXXFLAGS_DEBUG_static) -D_STLP_DEBUG -g
CXXFLAGS_STLDEBUG_dynamic = $(CXXFLAGS_DEBUG_dynamic) -D_STLP_DESIGNATED_DLL -D_STLP_DEBUG -g -ND -WD


.cpp{..\build\static\release}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_RELEASE_static) "$<"

.cpp{..\build\static\debug}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_DEBUG_static) "$<"

.cpp{..\build\static\stldebug}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_STLDEBUG_static) "$<"

.cpp{..\build\dynamic\release}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_RELEASE_dynamic) "$<"

.cpp{..\build\dynamic\debug}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_DEBUG_dynamic) "$<"

.cpp{..\build\dynamic\stldebug}.obj:
	$(CXX) -c -o"$@" $(CXXFLAGS_STLDEBUG_dynamic) "$<"

.c{..\build\static\release}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_RELEASE_static) "$<"

.c{..\build\static\debug}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_DEBUG_static) "$<"

.c{..\build\static\stldebug}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_STLDEBUG_static) "$<"

.c{..\build\dynamic\release}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_RELEASE_dynamic) "$<"

.c{..\build\dynamic\debug}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_DEBUG_dynamic) "$<"

.c{..\build\dynamic\stldebug}.obj:
	$(CC) -c -o"$@" $(CXXFLAGS_STLDEBUG_dynamic) "$<"

all:	directories all_static all_dynamic

directories:	..\lib ..\build ..\build\static ..\build\static\release ..\build\static\debug ..\build\static\stldebug ..\build\dynamic ..\build\dynamic\release ..\build\dynamic\debug ..\build\dynamic\stldebug

..\lib ..\build ..\build\static ..\build\static\release ..\build\static\debug ..\build\static\stldebug ..\build\dynamic ..\build\dynamic\release ..\build\dynamic\debug ..\build\dynamic\stldebug:
	mkdir $@

all_static:	..\lib\$(LIB_BASENAME)_static.lib ..\lib\$(LIB_BASENAME)_debug_static.lib ..\lib\$(LIB_BASENAME)_stldebug_static.lib

..\lib\$(LIB_BASENAME)_static.lib:	$(OBJS:build\=..\build\static\release\)
	*$(LIB) /n /p:32 "$@" -+"$(**: =-+)",,;

..\lib\$(LIB_BASENAME)_debug_static.lib:	$(OBJS:build\=..\build\static\debug\)
	*$(LIB) /n /p:128 "$@" -+"$(**: =-+)",,;

..\lib\$(LIB_BASENAME)_stldebug_static.lib:	$(OBJS:build\=..\build\static\stldebug\)
	*$(LIB) /n /p:128 "$@" -+"$(**: =-+)",,;


all_dynamic:	..\lib\$(LIB_BASENAME).dll ..\lib\$(LIB_BASENAME)_debug.dll ..\lib\$(LIB_BASENAME)_stldebug.dll

..\lib\$(LIB_BASENAME).dll:	$(OBJS:build\=..\build\dynamic\release\)
	*$(LINK) -WD -ND -L/IMPLIB:$(@R).lib -L/NOMAP -L/NODEBUG -o"$@" "$**" user32.lib kernel32.lib <<$(@R).def
LIBRARY "$(@F)"
DESCRIPTION 'STLport DLL for Digital Mars C/C++'
EXETYPE NT
SUBSYSTEM WINDOWS
CODE SHARED EXECUTE
DATA READWRITE

EXPORTS
	"?_STLP_cin@@3V?$basic_istream@DV?$char_traits@D@@@@A"
	"?_STLP_cout@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_cerr@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_clog@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?wcin@@3V?$basic_istream@_YV?$char_traits@_Y@@@@A"
	"?wcout@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wcerr@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wclog@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
<<

..\lib\$(LIB_BASENAME)_debug.dll:	$(OBJS:build\=..\build\dynamic\debug\)
	*$(LINK) -WD -ND -g -L/IMPLIB:$(@R).lib -L/NOMAP -L/DEBUG -o"$@" "$**" user32.lib kernel32.lib <<$(@R).def
LIBRARY "$(@F)"
DESCRIPTION 'STLport DLL for Digital Mars C/C++'
EXETYPE NT
SUBSYSTEM WINDOWS
CODE SHARED EXECUTE
DATA READWRITE

EXPORTS
	"?_STLP_cin@@3V?$basic_istream@DV?$char_traits@D@@@@A"
	"?_STLP_cout@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_cerr@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_clog@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?wcin@@3V?$basic_istream@_YV?$char_traits@_Y@@@@A"
	"?wcout@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wcerr@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wclog@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
<<

..\lib\$(LIB_BASENAME)_stldebug.dll:	$(OBJS:build\=..\build\dynamic\stldebug\)
	*$(LINK) -WD -ND -g -L/IMPLIB:$(@R).lib -L/NOMAP -L/DEBUG -o"$@" "$**" user32.lib kernel32.lib <<$(@R).def
LIBRARY "$(@F)"
DESCRIPTION 'STLport DLL for Digital Mars C/C++'
EXETYPE NT
SUBSYSTEM WINDOWS
CODE SHARED EXECUTE
DATA READWRITE

EXPORTS
	"?_STLP_cin@@3V?$basic_istream@DV?$char_traits@D@@@@A"
	"?_STLP_cout@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_cerr@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?_STLP_clog@@3V?$basic_ostream@DV?$char_traits@D@@@@A"
	"?wcin@@3V?$basic_istream@_YV?$char_traits@_Y@@@@A"
	"?wcout@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wcerr@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
	"?wclog@@3V?$basic_ostream@_YV?$char_traits@_Y@@@@A"
<<
